"use strict";

require("core-js/modules/es.regexp.constructor.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.regexp.to-string.js");

require("core-js/modules/es.string.match.js");

(function (mod) {
  if (typeof exports === "object" && typeof module === "object") // CommonJS
    mod(require("codemirror/lib/codemirror"));else if (typeof define === "function" && define.amd) // AMD
    define(["codemirror/lib/codemirror"], mod);else // Plain browser env
    mod(CodeMirror);
})(function (CodeMirror) {
  function wordRegexp(words) {
    return new RegExp("^((" + words.join(")|(") + "))\\b");
  }

  var keywordsList = ["default", "not", "package", "import", "as", "with", "else", "some"];
  var constantsList = ["true", "false", "null"];
  var keywords = wordRegexp(keywordsList);
  var constants = wordRegexp(constantsList);
  CodeMirror.registerHelper("hintWords", "rego", keywordsList.concat(constantsList));
  CodeMirror.defineMode("rego", function (config) {
    return {
      token: function token(stream, state) {
        if (stream.eatSpace()) return null;
        if (stream.match(/^#.*/)) return "comment";
        if (stream.match(/[{}\[\]\(\)]/)) return "bracket";
        if (stream.match(keywords)) return "keyword";
        if (stream.match(constants)) return "atom";
        if (stream.match(/[\=|\!\=|>|<|<\=|>\=|\+|-|\*|%|/|\||&|:\=]/)) return "operator";
        if (stream.match(/[\.,]/)) return "punctuation";
        if (stream.match(/\b[a-zA-Z_]+[a-zA-Z0-9_]*/)) return "variable";
        if (stream.match(/(-?(0|[1-9]\d*(\.\d+)?([eE][+-]?\d+)?))/)) return "number";
        if (stream.match(/"(\\["/bfnrt]|u[0-9a-fA-F]{4})*?[^"]*"/)) return "string";
        var ch = stream.next();
        return "error";
      },
      closeBrackets: "()[]{}''\"\"``",
      lineComment: "#"
    };
  });
  CodeMirror.defineMIME("text/x-rego", "rego");
});